/* Simple Chat
 * Copyright (c) 2008-2015 Alexander Sedov <imp@schat.me>
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <QProcess>

#include "ChatApp.h"
#include "sglobal.h"

#if defined(Q_OS_WIN) && defined(Q_CC_MSVC)
# include "ExceptionHandler.h"
#endif

int main(int argc, char *argv[])
{
# if defined(Q_OS_WIN) && defined(Q_CC_MSVC)
  initExceptionHandler();
# endif

  int ret = 0;
  QString appPath;
  QStringList args;

  {
    ChatApp app(argc, argv);
    if (app.isRunning())
      return 0;

    if (ChatApp::selfUpdate())
      return 0;

    appPath = app.applicationFilePath();
    args = app.arguments();
    args.takeFirst();

    app.start();
    ret = app.exec();
  }

  if (ChatApp::restartRequired) {
    QProcess::startDetached(LC('"') + appPath + LC('"'), args);
  }

  return ret;
}
